#!/bin/bash
version="0.1.0"

# ARG_OPTIONAL_SINGLE([ref],[r],[Name of the ref associated with this commit. Empty if none.])
# ARG_OPTIONAL_SINGLE([tag],[t],[Name of the tag associated with this commit. Empty if none.])
# ARG_VERSION([echo $version])
# ARG_HELP([])
# ARGBASH_GO()
# needed because of Argbash --> m4_ignore([
### START OF CODE GENERATED BY Argbash v2.9.0 one line above ###
# Argbash is a bash code generator used to get arguments parsing right.
# Argbash is FREE SOFTWARE, see https://argbash.io for more info
# Generated online by https://argbash.io/generate


# # When called, the process ends.
# Args:
# 	$1: The exit message (print to stderr)
# 	$2: The exit code (default is 1)
# if env var _PRINT_HELP is set to 'yes', the usage is print to stderr (prior to $1)
# Example:
# 	test -f "$_arg_infile" || _PRINT_HELP=yes die "Can't continue, have to supply file as an argument, got '$_arg_infile'" 4
die()
{
	local _ret="${2:-1}"
	test "${_PRINT_HELP:-no}" = yes && print_help >&2
	echo "$1" >&2
	exit "${_ret}"
}


# Function that evaluates whether a value passed to it begins by a character
# that is a short option of an argument the script knows about.
# This is required in order to support getopts-like short options grouping.
begins_with_short_option()
{
	local first_option all_short_options='rtvh'
	first_option="${1:0:1}"
	test "$all_short_options" = "${all_short_options/$first_option/}" && return 1 || return 0
}

# THE DEFAULTS INITIALIZATION - OPTIONALS
_arg_ref=
_arg_tag=


# Function that prints general usage of the script.
# This is useful if users asks for it, or if there is an argument parsing error (unexpected / spurious arguments)
# and it makes sense to remind the user how the script is supposed to be called.
print_help()
{
	printf 'Usage: %s [-r|--ref <arg>] [-t|--tag <arg>] [-v|--version] [-h|--help]\n' "$0"
	printf '\t%s\n' "-r, --ref: Name of the ref associated with this commit. Empty if none. (no default)"
	printf '\t%s\n' "-t, --tag: Name of the tag associated with this commit. Empty if none. (no default)"
	printf '\t%s\n' "-v, --version: Prints version"
	printf '\t%s\n' "-h, --help: Prints help"
}


# The parsing of the command-line
parse_commandline()
{
	while test $# -gt 0
	do
		_key="$1"
		case "$_key" in
			# We support whitespace as a delimiter between option argument and its value.
			# Therefore, we expect the --ref or -r value.
			# so we watch for --ref and -r.
			# Since we know that we got the long or short option,
			# we just reach out for the next argument to get the value.
			-r|--ref)
				test $# -lt 2 && die "Missing value for the optional argument '$_key'." 1
				_arg_ref="$2"
				shift
				;;
			# We support the = as a delimiter between option argument and its value.
			# Therefore, we expect --ref=value, so we watch for --ref=*
			# For whatever we get, we strip '--ref=' using the ${var##--ref=} notation
			# to get the argument value
			--ref=*)
				_arg_ref="${_key##--ref=}"
				;;
			# We support getopts-style short arguments grouping,
			# so as -r accepts value, we allow it to be appended to it, so we watch for -r*
			# and we strip the leading -r from the argument string using the ${var##-r} notation.
			-r*)
				_arg_ref="${_key##-r}"
				;;
			# See the comment of option '--ref' to see what's going on here - principle is the same.
			-t|--tag)
				test $# -lt 2 && die "Missing value for the optional argument '$_key'." 1
				_arg_tag="$2"
				shift
				;;
			# See the comment of option '--ref=' to see what's going on here - principle is the same.
			--tag=*)
				_arg_tag="${_key##--tag=}"
				;;
			# See the comment of option '-r' to see what's going on here - principle is the same.
			-t*)
				_arg_tag="${_key##-t}"
				;;
			# The version argurment doesn't accept a value,
			# we expect the --version or -v, so we watch for them.
			-v|--version)
				echo $version
				exit 0
				;;
			# We support getopts-style short arguments clustering,
			# so as -v doesn't accept value, other short options may be appended to it, so we watch for -v*.
			# After stripping the leading -v from the argument, we have to make sure
			# that the first character that follows coresponds to a short option.
			-v*)
				echo $version
				exit 0
				;;
			# See the comment of option '--version' to see what's going on here - principle is the same.
			-h|--help)
				print_help
				exit 0
				;;
			# See the comment of option '-v' to see what's going on here - principle is the same.
			-h*)
				print_help
				exit 0
				;;
			*)
				_PRINT_HELP=yes die "FATAL ERROR: Got an unexpected argument '$1'" 1
				;;
		esac
		shift
	done
}

# Now call all the functions defined above that are needed to get the job done
parse_commandline "$@"

# OTHER STUFF GENERATED BY Argbash

### END OF CODE GENERATED BY Argbash (sortof) ### ])




# Release Types:
# Stable
# Release Candidate
# Snaphot
# Experimental
# Unknown

release_type=unknown
version_core_regex="(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)\.(0|[1-9][0-9]*)"
stable_release_regex="^${version_core_regex}$"
rc_release_regex="^${version_core_regex}(-rc\.[1-9][0-9]*)*$"
snapshot_release_regex="^master|main|develop(ment)?|release-${version_core_regex}|hotfix-(.+)$"

# If tag is set, it could be stable, release candidate, or snapshot.
# Effectively ignore the value of the ref name
if [ -n "${_arg_tag}" ]; then

  if [[ "${_arg_tag}" =~ $stable_release_regex ]]; then

    release_type="stable"

  elif [[ "${_arg_tag}" =~ $rc_release_regex ]]; then

    release_type="release-candidate"

  else

    release_type="snapshot"

  fi

# If tag is not set but the ref is, it could a snapshot or experimental
elif [ -n "${_arg_ref}" ]; then

  if [[ "${_arg_ref}" =~ $snapshot_release_regex ]]; then

    release_type="snapshot"

  else

    release_type="experimental"

  fi

else

  die "tag name and ref name are both empty!" 1

fi

echo "${release_type}"
